---
title: "Resource IDs"
description: "Use different resource ID types, such as EHR IDs and HSA IDs, in Leyr API requests."
canonical_url: "https://docs.leyr.io/api/guides/resource-id"
---
# Resource IDs

> Use different resource ID types, such as EHR IDs and HSA IDs, in Leyr API requests.

It is possible to use different types of resource IDs in requests to Leyr API.
Get resource details, book appointments, create medical notes and documents using EHR IDs, HSA IDs and more.

## Supported Resource ID types

Following resource ID types are generally supported.

- EHR ID - internal identifier, used by EHR vendors internally
- Norwegian Personal Number - national identity number in Norway
- Swedish Personal Number - national identity number in Sweden
- HSA ID - Hälso- och Sjukvårdens Adressregister identifier, specific to Sweden
- Header - used to pass resource ID in the header parameter. [Read more](#header)

<u-alert color="warning" variant="subtle" icon="heroicons:shield-exclamation">
<template v-slot:description="">

**Security Recommendation.** Leyr recommends using the header approach to pass sensitive resource data. This helps protect against information exposure through query strings and path params in URLs, a common OWASP vulnerability. [Learn more about this vulnerability](https://owasp.org/www-community/vulnerabilities/Information_exposure_through_query_strings_in_url).

</template>
</u-alert>

Different EHR vendors support different types of resource IDs:

<table>
<thead>
  <tr>
    <th>
      EHR
    </th>
    
    <th>
      Supported Resource ID Types
    </th>
  </tr>
</thead>

<tbody>
  <tr>
    <td>
      Acuity Scheduling
    </td>
    
    <td>
      EHR ID
    </td>
  </tr>
  
  <tr>
    <td>
      Anita Systems
    </td>
    
    <td>
      EHR ID
    </td>
  </tr>
  
  <tr>
    <td>
      Athenaone
    </td>
    
    <td>
      EHR ID
    </td>
  </tr>
  
  <tr>
    <td>
      Athenapractice
    </td>
    
    <td>
      EHR ID
    </td>
  </tr>
  
  <tr>
    <td>
      Avon
    </td>
    
    <td>
      EHR ID
    </td>
  </tr>
  
  <tr>
    <td>
      Cerner
    </td>
    
    <td>
      EHR ID
    </td>
  </tr>
  
  <tr>
    <td>
      Cliniko
    </td>
    
    <td>
      EHR ID
    </td>
  </tr>
  
  <tr>
    <td>
      Dentally
    </td>
    
    <td>
      EHR ID
    </td>
  </tr>
  
  <tr>
    <td>
      DIPS
    </td>
    
    <td>
      EHR ID
    </td>
  </tr>
  
  <tr>
    <td>
      DynamicHealth
    </td>
    
    <td>
      EHR ID
    </td>
  </tr>
  
  <tr>
    <td>
      EasyPractice
    </td>
    
    <td>
      EHR ID
    </td>
  </tr>
  
  <tr>
    <td>
      Epic
    </td>
    
    <td>
      EHR ID
    </td>
  </tr>
  
  <tr>
    <td>
      Exact
    </td>
    
    <td>
      EHR ID
    </td>
  </tr>
  
  <tr>
    <td>
      Frenda
    </td>
    
    <td>
      EHR ID
    </td>
  </tr>
  
  <tr>
    <td>
      GoSensei
    </td>
    
    <td>
      EHR ID
    </td>
  </tr>
  
  <tr>
    <td>
      J4
    </td>
    
    <td>
      EHR ID
    </td>
  </tr>
  
  <tr>
    <td>
      Kaddio
    </td>
    
    <td>
      EHR ID
    </td>
  </tr>
  
  <tr>
    <td>
      Konfidens
    </td>
    
    <td>
      EHR ID
    </td>
  </tr>
  
  <tr>
    <td>
      MakePlans
    </td>
    
    <td>
      EHR ID
    </td>
  </tr>
  
  <tr>
    <td>
      Muntra
    </td>
    
    <td>
      EHR ID
    </td>
  </tr>
  
  <tr>
    <td>
      Nextech
    </td>
    
    <td>
      EHR ID
    </td>
  </tr>
  
  <tr>
    <td>
      Opus Dental
    </td>
    
    <td>
      EHR ID
    </td>
  </tr>
  
  <tr>
    <td>
      PasientSky
    </td>
    
    <td>
      EHR ID
    </td>
  </tr>
  
  <tr>
    <td>
      Physica
    </td>
    
    <td>
      EHR ID
    </td>
  </tr>
  
  <tr>
    <td>
      Pridok
    </td>
    
    <td>
      EHR ID
    </td>
  </tr>
  
  <tr>
    <td>
      Prorenata
    </td>
    
    <td>
      EHR ID
    </td>
  </tr>
  
  <tr>
    <td>
      Psykbase
    </td>
    
    <td>
      EHR ID
    </td>
  </tr>
  
  <tr>
    <td>
      SolvIT
    </td>
    
    <td>
      EHR ID
    </td>
  </tr>
  
  <tr>
    <td>
      Speare
    </td>
    
    <td>
      EHR ID
    </td>
  </tr>
  
  <tr>
    <td>
      Takecare
    </td>
    
    <td>
      EHR ID
    </td>
  </tr>
  
  <tr>
    <td>
      Vena
    </td>
    
    <td>
      EHR ID
    </td>
  </tr>
  
  <tr>
    <td>
      WebDoc
    </td>
    
    <td>
      EHR ID, HSA ID, Swedish Personal Number
    </td>
  </tr>
</tbody>
</table>

## Use Resource ID types

Parameters, where Resource ID is used, and where the different types can be applied:

- `resource_id` path parameter of Get Resource Details endpoint
- `resource_id` query parameter in Get Appointments endpoint
- `resource_id` field in JSON body of Create Appointment endpoint
- `resource_id` path parameter of Get Resource Schedule endpoint
- `resource_id` path parameter of Create Resource Schedule endpoint

Where `resource_id` is passed in, e.g.

```text
GET /api/emrs/pasientsky/care-units/L0_10/appointments?resource_id=abc_12345
```

or

```text
POST /api/emrs/webdoc/care-units/L0_1/resources/hsa_id:SE2321000131-E000000012345/schedules
```

as well as in all applicable cases mentioned above, it is possible to construct `resource_id` parameter, using the following structure:

```text
{resource_id_type}:{resource_id_value}
```

where currently supported `resource_id_type` are:

- `emr_id`
- `se_personal_number`
- `no_personal_number`
- `hsa_id`

## Examples

Examples of fully constructed `resource_id` are:

- `emr_id:abc_12345`
- `se_personal_number:191212121212`
- `no_personal_number:26258605879`
- `hsa_id:SE2321000131-E000000012345`

<u-alert color="primary" variant="subtle">
<template v-slot:description="">

It is also possible to skip the prefix completely, e.g. by passing only `abc_12345` as `resource_id`. In this case Leyr will treat it as `emr_id`, i.e. an internal Resource identifier, used by the target EHR system.
<br />

<br />


In practice this means `emr_id:abc_12345` and `abc_12345` are equivalent.

</template>
</u-alert>

### emr_id

```text
GET /api/emrs/pasientsky/care-units/L0_10/appointments?resource_id=emr_id:abc_12345
```

In this case Leyr will look for appointments for a resource, which **internal EHR ID** is `abc_12345`

### hsa_id

```text
POST /api/emrs/webdoc/care-units/L0_10/appointments

{
  "resource_id": "hsa_id:SE2321000131-E000000012345",
  "start_time": "2022-01-01T10:00:00",
  "end_time": "2022-01-01T10:30:00",
  "patient_id": "L0_12345",
  "healthcare_service_id": "L0_12345"
}
```

In this case Leyr will look up a resource using the HSA ID `SE2321000131-E000000012345`, and book an appointment with that resource.

### se_personal_number

```text
GET /api/emrs/webdoc/care-units/L0_1/resources/se_personal_number:191212121212
```

In this case Leyr will look up a resource whose **Swedish Personal Number** is `191212121212`.

### no_personal_number

```text
GET /api/emrs/webdoc/care-units/L0_1/resources/no_personal_number:191212121212
```

In this case Leyr will look up a resource whose **Norwegian Personal Number** is `26258605879`.

### Nothing provided

```text
GET /api/emrs/takecare/care-units/L0_10/appointments?resource_id=abc_12345
```

The value passed there is treated as `emr_id`.
In this case Leyr will look for appointments for a resource, which **internal EHR ID** is `abc_12345`.

### header

While Leyr never logs sensitive data (including resource IDs in URLs and query parameters), it's a known issue that some intermediary servers, DNS providers, and networking tools might log URLs or query parameters as part of their standard operation. To provide our customers with an additional layer of security when handling sensitive resource information, we've implemented the ability to pass resource IDs through headers instead of URLs or request bodies.

This header-based approach ensures that sensitive resource identifiers are less likely to appear in various system logs along the request path, as headers are typically handled with more discretion in logging systems.

To use a header reference, construct the parameter value using the following structure:

```text
header:{header_name}
```

where `header_name` is the name of the header containing the actual resource ID.

In this case, Leyr will look for the resource ID in the header with the name `header_name` and take the value from there.

#### Examples

Using header reference in path parameter:

```text
Headers:
x-resource-id: se_personal_number:191212121212

GET /api/emrs/webdoc/care-units/L0_1/resources/header:x-resource-id
```

Using header reference in query parameter:

```text
Headers:
x-current-resource: hsa_id:SE2321000131-E000000012345

GET /api/emrs/webdoc/care-units/L0_10/appointments?resource_id=header:x-current-resource
```

Using header reference in request body:

```text
Headers:
x-referring-resource: emr_id:abc_12345

POST /api/emrs/pasientsky/care-units/L0_10/appointments
{
  "resource_id": "header:x-referring-resource",
  "start_time": "2022-01-01T10:00:00",
  "end_time": "2022-01-01T10:30:00",
  "patient_id": "L0_12345",
  "healthcare_service_id": "L0_12345"
}
```

The value in the referenced header must still be a valid resource ID format, as described in the beginning of this page.

For example, if your header contains a Swedish personal number, the header value should be `se_personal_number:191212121212`, and if you want to use EHR ID - it should be `emr_id:abc_12345` or `abc_12345` (which will be treated as an `emr_id`).

## Next steps

<card-group>
<card icon="i-heroicons-calendar" title="Show Doctor's Availability" to="https://docs.leyr.io/api/quickstart/show-availability">

Find resources, services, and open timeslots for booking.

</card>

<card icon="i-heroicons-user" title="Patient IDs" to="https://docs.leyr.io/api/guides/patient-id">

Use EHR IDs, national IDs, and other identifier types for patients.

</card>
</card-group>


## Sitemap

See the full [sitemap](https://docs.leyr.io/sitemap.md) for all pages.
